// mygraph.cp
#pragma warning(disable : 4996)
#pragma warning(disable : 4244)
#include "stdafx.h"
#include "MyGraph.h"
#include <math.h>

CMyCM::CMyCM(CDC* pcd, RECT r, int nx, int ny)
{
  pcdc = pcd;
  wcmr = r;
  fMin = 0.0;
  fMax = 1.0;
  NX = nx; 
  NY = ny;
}
int CMyCM::PaintMap(COLORREF wcmColor1, COLORREF wcmColor2)
{
  int m, n, i, j, curval;
  int PixLenX, PixLenY;
  double amp;
  int cx1y1, cx1y2, cx2y1, cx2y2;
  int y1, y2, x1, x2, x2m, y2m, y1t, y2t;
  int wcmNumOfColors = 32;
  COLORREF* wcmRGB = new COLORREF[wcmNumOfColors];
  int Red, Green, Blue;
  int Red1   = GetRValue(wcmColor1);
  int Green1 = GetGValue(wcmColor1);
  int Blue1  = GetBValue(wcmColor1);
  int Red2   = GetRValue(wcmColor2);
  int Green2 = GetGValue(wcmColor2);
  int Blue2  = GetBValue(wcmColor2);
  wcmRGB[0]=RGB(Red1, Green1, Blue1);
  for(i=1; i<wcmNumOfColors; i++){
    Red   = Red1  +(Red2  -Red1  )*i/(wcmNumOfColors-1);
    Green = Green1+(Green2-Green1)*i/(wcmNumOfColors-1);
    Blue  = Blue1 +(Blue2 -Blue1 )*i/(wcmNumOfColors-1);
    wcmRGB[i]=RGB(Red, Green, Blue);
  }
  long lWeightMax = 16000L;
  long lValueMax = 16000L;
  if (fMax==fMin)
    amp = 0;
  else
    amp = double(lValueMax)/(fMax - fMin);
  PixLenX = wcmr.right  - wcmr.left;
  PixLenY = wcmr.bottom - wcmr.top;
  int PixPerCellX = (PixLenX-1)/(NX-0) + 1;
  int PixPerCellY = (PixLenY-1)/(NY-0) + 1;
  int k, p;
  int pp = PixPerCellX * PixPerCellY;
  int* px1y1 = new int[pp];
  int* px2y1 = new int[pp];
  int* px2y2 = new int[pp];
  int* px1y2 = new int[pp];
  if(PixPerCellX == 1 && PixPerCellY == 1){
     px1y1[0] = lWeightMax;
     px2y1[0] = 0;
     px2y2[0] = 0;
     px1y2[0] = 0;
  }
  else if(PixPerCellX == 1){
    p = 0;
    k = PixPerCellY-1;
    lWeightMax = (lWeightMax/k)*k;
    for(j=0; j<PixPerCellY; j++)
    {
      px1y1[p] = (PixPerCellY-j-1)*lWeightMax/k;
      px2y1[p] = 0;
      px2y2[p] = 0;
      px1y2[p] = j*lWeightMax/k;
      p++;
    }
  }
  else if(PixPerCellY == 1){
    p = 0;
    k = PixPerCellX-1;
    lWeightMax = (lWeightMax/k)*k;
    for(i=0; i<PixPerCellX; i++){
      px1y1[p] = (PixPerCellX-i-1)*lWeightMax/k;
      px2y1[p] = i*lWeightMax/k;
      px2y2[p] = 0;
      px1y2[p] = 0;
      p++;
    }
  }
  else{
    p = 0;
    k = (PixPerCellX-1) * (PixPerCellY-1);
    lWeightMax = (lWeightMax/k)*k;
    for(i=0; i < PixPerCellX; i++)
      for(j=0; j < PixPerCellY; j++){
        px1y1[p] = ((PixPerCellX-i-1)*(PixPerCellY-j-1))*lWeightMax/k;
        px2y1[p] = (i                *(PixPerCellY-j-1))*lWeightMax/k;
        px2y2[p] = (i                *j                )*lWeightMax/k;
        px1y2[p] = ((PixPerCellX-i-1)*j                )*lWeightMax/k;
        p++;
    }
  }
  x2 = wcmr.left + 1;
  for (n=0; n<NX; n++){
    x1 = x2 - 1;
    x2 += PixPerCellX-1;
    x2m = wcmr.left + ((n+1)*PixLenX)/(NX-0);
    if(x2<x2m){x1++; x2++;}
    y2t = wcmr.top + 1;
    for (m=0; m<NY; m++){
      y1t = y2t - 1;
      y2t += PixPerCellY-1;
      y2m = wcmr.top + ((m+1)*PixLenY)/(NY-0);
      if(y2t<y2m){y1t++; y2t++;}
      y1 = wcmr.bottom - (y2t - wcmr.top);
      y2 = wcmr.bottom - (y1t - wcmr.top);
      cx1y2 = amp*( wcmpdfii(m,n)     - fMin);
      cx2y2 = amp*( wcmpdfii(m,n+1)   - fMin);
      cx2y1 = amp*( wcmpdfii(m+1,n+1) - fMin);
      cx1y1 = amp*( wcmpdfii(m+1,n)   - fMin);
      p = 0;
      for (i=0; i<PixPerCellX; i++) 
        for (j=0; j<PixPerCellY; j++){
          curval = (((px1y2[p]*cx1y2 + px2y2[p]*cx2y2 + px2y1[p]*cx2y1 + px1y1[p]*cx1y1)/lWeightMax)
            *(wcmNumOfColors+1))/lValueMax;
          if (curval < 0) curval = 0;
          else if (curval >= wcmNumOfColors) curval = wcmNumOfColors-1;
//          curval = 3;
          pcdc->SetPixel(x1+i, y1+j, wcmRGB[curval]);
          p++;
      }
    }
  }
  delete px1y1;
  delete px1y2;
  delete px2y1;
  delete px2y2;
  char buf[128];
    sprintf(buf, "%8.3lg", fMin);
//    TextOut(>GetWindow)->m_hWnd, wcmr.left+3, wcmr.top+3,  buf, strlen(buf));
    sprintf(buf, "%8.3lg", fMax);
//    TextOut(pcdc->m_hWnd, wcmr.left+3, wcmr.top+18, buf, strlen(buf));
  delete wcmRGB;
  return FALSE;
}
int MinMax(double& xmi, double& xma, double* xx, int ia, int ib)
{ 
  xmi = xma = xx[ia];
  for(int m=ia+1; m<ib; m++){
    if(xx[m]<xmi) xmi = xx[m];
    if(xx[m]>xma) xma = xx[m];
  }
  return true;
} 



