// MyFile: mygraph.h

int MinMax(double& xmi, double& xma, double* xx, int ia, int ib);

class CMyGraph
{
public:
  CDC* pcdc;  
  RECT rectex, rectin;
  double xmin, xmax, ymin, ymax;
  CBrush BrEx, BrIn;  
  COLORREF colex, colin;
  CMyGraph(CDC* pcd, RECT r)
  {
    pcdc = pcd; 
    rectex = r; 
    colex = RGB(200, 150, 100);        
    colin = RGB(70, 150, 230);
  	BrEx.CreateSolidBrush(colex);      
    BrIn.CreateSolidBrush(colin);
	  pcdc->FillRect(&rectex, &BrEx);
      rectin.left   = rectex.left+4;		
      rectin.top    = rectex.top+4;
	  rectin.right  = rectex.right-4;		
      rectin.bottom = rectex.bottom-4;
	  pcdc->FillRect(&rectin, &BrIn);
  }
  int Prepare(double* xx, double* yy, int ia, int ib)
  {
    MinMax(xmin, xmax, xx, ia, ib);    
    MinMax(ymin, ymax, yy, ia, ib);
    return true;
  }
  ~CMyGraph(){}
inline int SetPixel0(int x, int y)
{
  pcdc->SetPixel(x, y, RGB(0, 0, 0)); 
  return NULL;
}
inline int SetPixel1(int x, int y)
{
  pcdc->SetPixel(x, y, RGB(255, 255, 255)); 
  return NULL;
}
inline int MoveTo(double x, double y)
{  
  pcdc->MoveTo(
  rectin.left + int(((x-xmin)/(xmax-xmin))*(rectin.right -rectin.left)),
  rectin.bottom - int(((y-ymin)/(ymax-ymin))*(rectin.bottom-rectin.top)));
  return NULL;
}
inline int LineTo(double x, double y)
{  
  pcdc->LineTo(
  rectin.left + int(((x-xmin)/(xmax-xmin))*(rectin.right -rectin.left)),
  rectin.bottom - int(((y-ymin)/(ymax-ymin))*(rectin.bottom-rectin.top)));
  return NULL;
}
int Line(double* xx, double* yy, int ia, int ib)
{ 
  MoveTo(xx[ia], yy[ia]);
  for(int m=ia+1; m<ib; m++) 
    LineTo(xx[m], yy[m]);
  return true;
}
};
typedef double DFUNCLL(int, int);
typedef DFUNCLL* PDFUNCLL;
class CMyCM
{
public:
  CDC* pcdc;
  PDFUNCLL wcmpdfii;
  RECT wcmr;
  int NX, NY;
  double fMin, fMax;
  CMyCM(CDC* pcd, RECT, int NX, int NY);
  int SetFun(PDFUNCLL pf)
    {wcmpdfii = pf; return true;}
  int PaintMap(
	  COLORREF wcmColor1=RGB(0, 0, 0), 
	  COLORREF wcmColor2=RGB(255, 255, 255));
};

